#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	void open();
	static bool getModuleProperties (SEModuleProperties* properties);
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);

private:
	bool CreateSharedLookup( char *p_table_name, void *p_table_pointer, float p_sample_rate, int p_size);
	void SetupLookupTable();
	void FillLookupTable();
	void OnLookupTableChanged();

	float ohapow(float a, float b);

	float *output1_buffer;
	float *input1_buffer;
	float *input2_buffer;

	float phase;

#define FATOSC_TABLESIZE 1024

	float *f_table;	// fatness LUT
	float *p_table; // positive freq LUT
	float *n_table; // negative freq LUT
	float *tx;		// helper

	const float FATOSC_TABLESIZE_MINUS_1; // = FATOSC_TABLESIZE-1;
	const int FATOSC_TABLESIZE_MINUS_1_INT; // = FATOSC_TABLESIZE-1;

#define logTSIZE 1024
#define expTSIZE 1024

	float *logT;
	float *expT;

	float log16;
	float cexp;

};
#endif
